package com.cslab.HomeApp;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.AdapterView.OnItemSelectedListener;

public class Appliance_control extends Activity implements OnClickListener {
	/** Called when the activity is first created. */
	private String Control_msg = null;
	private String RoomNum = null;
	static final private int Failed_Diglog = 1;
	
	public static final String MYPREFS = "mySharedPreferences";
	private String ip;
	private int port;
	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.appliance);

	    // Spinner 
	    Spinner s = (Spinner) findViewById(R.id.spinner);
	    ArrayAdapter<?> adapter = ArrayAdapter.createFromResource(
	            this, R.array.seleRoom, android.R.layout.simple_spinner_item);
	    adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
	    s.setAdapter(adapter);
	    
	    // Button Event Listener 
	    Button Humi_on = (Button)findViewById(R.id.humidifier_on);
	    Button Humi_off = (Button)findViewById(R.id.humidifier_off);
	    Button fan_on = (Button)findViewById(R.id.fanOn);
	    Button fan_off = (Button)findViewById(R.id.fanOff);
	    Button heater_on = (Button)findViewById(R.id.heaterOn);
	    Button heater_off = (Button)findViewById(R.id.heaterOff);
	    Button all_on = (Button)findViewById(R.id.allon);
	    Button all_off = (Button)findViewById(R.id.allOff);
	    
	    Humi_on.setOnClickListener(this);
	    Humi_off.setOnClickListener(this);
	    fan_on.setOnClickListener(this);
	    fan_off.setOnClickListener(this);
	    heater_on.setOnClickListener(this);
	    heater_off.setOnClickListener(this);
	    all_on.setOnClickListener(this);
	    all_off.setOnClickListener(this);
	    
	    // Spinner Event
	    s.setOnItemSelectedListener(new OnItemSelectedListener() {
			@Override
			public void onItemSelected(AdapterView<?> arg0, View arg1,
					int arg2, long arg3) {
				String RoomSelected;
				RoomSelected = arg0.getSelectedItem().toString();
				if(RoomSelected.compareTo("ȹ") == 0)
					RoomNum = "1";
				else if(RoomSelected.compareTo("Ž") == 0)
					RoomNum = "2";
				else if(RoomSelected.compareTo("") == 0)
					RoomNum = "3";
				//Toast toast = Toast.makeText(getApplicationContext(), RoomNum, Toast.LENGTH_SHORT);
				//toast.show();
			}

			@Override
			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub
			}
	    });
	}
	
	// Button Event
	@Override
	public void onClick(View v) {
		// Toast ʱȭ
		int duration = Toast.LENGTH_SHORT;
		String ToastMsg = "";
		
		// Client Thread
		Client client = new Client();
		loadPreferences();
		client.set_ip_port(ip, port);
		Thread cThread = new Thread(client);
		
		// Toast ޼, Ʈ ޼ 
		switch (v.getId()) {
			case R.id.humidifier_on:
				Control_msg = "Humidifier" + RoomNum + "_on";
				client.set_string(Control_msg);
				ToastMsg = " On";
				break;
			case R.id.humidifier_off:
				Control_msg = "Humidifier" + RoomNum + "_off";
				client.set_string(Control_msg);
				ToastMsg = " Off";
				break;
			case R.id.fanOn:
				Control_msg = "Fan" + RoomNum + "_on";
				client.set_string(Control_msg);
				ToastMsg = "ǳ On";
				break;
			case R.id.fanOff:
				Control_msg = "Fan" + RoomNum + "_off";
				client.set_string(Control_msg);
				ToastMsg = "ǳ Off";
				break;
			case R.id.heaterOn:
				Control_msg = "Heater" + RoomNum + "_on";
				client.set_string(Control_msg);
				ToastMsg = " On";
				break;
			case R.id.heaterOff:
				Control_msg = "Heater" + RoomNum + "_off";
				client.set_string(Control_msg);
				ToastMsg = " Off";
				break;
			case R.id.allon:
				Control_msg = "All_app" + RoomNum + "_on";
				client.set_string(Control_msg);
				ToastMsg = "  On";
				break;
			case R.id.allOff:
				Control_msg = "All_app" + RoomNum + "_off";
				client.set_string(Control_msg);
				ToastMsg = "  Off";
				break;
		}
		
		//  
		cThread.start();
		
		//  ޼
		if(client.get_string().compareTo("error") == 0) {
			showDialog(Failed_Diglog);
		}
		// Toast 
		else {
			Toast toast = Toast.makeText(getApplicationContext(), ToastMsg, duration);
			toast.show();
		}
	}
	
	// Error Dialog
	@Override
	public Dialog onCreateDialog(int id){
		String button1_String = "Ȯ";
		switch(id) {
			case (Failed_Diglog) :
				AlertDialog.Builder Dialog_1 = new AlertDialog.Builder(this);
				Dialog_1.setTitle("");
				Dialog_1.setMessage("  Ȱ ʽϴ.   ¸ ϼ");
				Dialog_1.setPositiveButton(button1_String, null);
				return Dialog_1.create();
		}
		return null;
	}
	
	// ȯ   Load
	public void loadPreferences() {
		int mode = Activity.MODE_PRIVATE;
		SharedPreferences mySharedPreferences = getSharedPreferences(MYPREFS, mode);
		
		ip = mySharedPreferences.getString("ip", "");
		port = mySharedPreferences.getInt("port", 0);
	}
}