#include <mega128.h>
#include <delay.h>
#include <string.h>
#include <stdio.h>     

// LCD Ʈ 
#define LCD_RS PORTA.0
#define LCD_RW PORTA.1
#define LCD_E PORTA.2 
#define LCD_DATA PORTC

#include "lcd.c"

// Ʈ ޼
#define con1_on '1'
#define con1_off '2'
#define con2_on '3'
#define con2_off '4'
#define con3_on '5'
#define con3_off '6'
#define all_on_1 '7'
#define all_off_1 '8'
#define con4_on '9'
#define con4_off '0'
#define con5_on 'a'
#define con5_off 'b'
#define con6_on 'c'
#define con6_off 'd'
#define all_on_2 'e'
#define all_off_2 'f'

unsigned char ch;

// Ʈ 
void port_init()
{
        DDRA = DDRC = DDRB = 0xff;
        PORTA = 0xff;
}

void main(void)
{       
        port_init();
        lcd_init();
                  
        UCSR0A = 0;    //  , U2X0  = 0
        UCSR0B = 0x98;  // ۼ ο̺, RXEN0 = TXEN0 = 1 
        // ſϷ ͷƮ ο̺ (RXCIE0 = 1)
        UCSR0C = 0x86; // 1Ʈ  Ʈ, 񵿱  8Ʈ
                        // USBS0 = 0, UCSZ01 UCSZ00 = 1 1
        
        UBRR0H = 0; // Ʈ 9600bps
        UBRR0L = 23; // echo print,  ۽
        SREG = 0x80;
        
        while(1)
			;
} 

//  ͷƮ
interrupt[USART0_RXC] void usart0_rxc(void) 
{
    ch = UDR0;

	// ޼   Ʈ
    if(ch == con1_on)
        PORTB = PORTB | 0x01;
    else if(ch == con1_off)
        PORTB = PORTB & 0xfe;
    else if(ch == con2_on)
        PORTB = PORTB | 0x02;
    else if(ch == con2_off)
        PORTB = PORTB & 0xfd;
    else if(ch == con3_on)
        PORTB = PORTB | 0x04;
    else if(ch == con3_off)
        PORTB = PORTB & 0xfb; 
    else if(ch == con4_on)
        PORTB = PORTB | 0x08;
    else if(ch == con4_off)
        PORTB = PORTB & 0xf7; 
    else if(ch == con5_on)
        PORTB = PORTB | 0x10;
    else if(ch == con5_off)
        PORTB = PORTB & 0xef; 
    else if(ch == con6_on)
        PORTB = PORTB | 0x20;
    else if(ch == con6_off)
        PORTB = PORTB & 0xdf;
    else if(ch == all_on_1)
        PORTB = PORTB | 0x07;
    else if(ch == all_off_1)
        PORTB = PORTB & 0x38;
    else if(ch == all_on_2)
        PORTB = PORTB | 0x38;
    else if(ch == all_off_2)
        PORTB = PORTB & 0x07; 
    
    UCSR0B |= 0x20; // ۽  empty ͷƮ  UDRIE = 1 
}

interrupt[USART0_DRE] void usart0_dre(void) // ۽
{
        UDR0 = ch; // ŵ ch USART ۽ ۿ 
        UCSR0B &= 0xdf; // ۽  empty ͷƮ  UDRIE = 0;
}