/////////////////////////////////////////////////////////////////////////////////////
// HomeApp 
/////////////////////////////////////////////////////////////////////////////////////

//  
#include "Common.h"
#include "CUBRID.h"
#include "Network.h"
#include <netinet/in.h>

// Ǿ ִ Ŭ̾Ʈ  ó Լ
void addClient(int s, struct sockaddr_in *newcliaddr);
void removeClient(int s);
int getmax();

//  Ŭ̾Ʈ ,  
int clisock_list[MAX_SOCK];
int client_count = 0;
int	nSocket;

int main()
{
	// 
	struct sockaddr_in cliaddr;
	int maxfdpl;
	int nAccept;
	int addrlen = sizeof(struct sockaddr_in);

	int con;
	T_CCI_ERROR error;
	char sql[MAX_BUF];

	fd_set read_fds;

	int i;
	char strBuf[MAX_BUF];
	double temp, humi;
	char *light, *pCon1, *pCon2, *pCon3, *pCon4, *pCon5, *pCon6;
	int set_temp, set_humi;

	int nSerialFD;

	// TCP/IP  
	if((nSocket = OpenNetwork(NETWORK_PORT)) < 0)
		return 0;

	// DB 
	if((con = DB_Connect()) <= 0)
		return 0;

	// ø  ( ATMEGA )
	if((nSerialFD = open_serial("/dev/ttyS0", ATMEGA_BAUD, 0, 0)) < 0) 
		return 0;

	while(1)
	{
		// NON-BLOCKING MODE
		FD_ZERO(&read_fds);
		FD_SET(nSocket, &read_fds);
		for(i = 0; i < client_count; i++)
			FD_SET(clisock_list[i], &read_fds);
		// ִ   
		maxfdpl = getmax() + 1;
		
		if(select(maxfdpl, &read_fds, NULL, NULL, NULL) < 0)
			perror("Select fail");

		// Ŭ̾Ʈ  ó
		if(FD_ISSET(nSocket, &read_fds))
		{
			nAccept = accept(nSocket, (struct sockaddr *) &cliaddr, &addrlen);
			if(nAccept < 0)
				perror("Accept fail");
			addClient(nAccept, &cliaddr);
		}
		
		// Ŭ̾Ʈ б ȣ  Ǿ  
		for(i = 0; i< client_count; i++)
		{
			if(FD_ISSET(clisock_list[i], &read_fds))
			{
				// ϵǴ ޼   ó
				switch(NetRecv(nAccept))
				{
					case REQ_ERR :
						break;
					// ǳ  ȸ
					case REQ_STAT_1:
						light = (char *)malloc(BRIGHT_BUF);
						sprintf(sql, ROOM_SELECT, 1);
						select_data_status(con, sql, &temp, &humi, &light);
						sprintf(strBuf, "%.2f_%.2f_%s", temp, humi, light);
						NetSend(clisock_list[i], strBuf);
						free(light);
						break;
					case REQ_STAT_2:
						light = (char *)malloc(BRIGHT_BUF);
						sprintf(sql, ROOM_SELECT, 2);
						select_data_status(con, sql, &temp, &humi, &light);
						sprintf(strBuf, "%.2f_%.2f_%s", temp, humi, light);
						NetSend(clisock_list[i], strBuf);
						free(light);
						break;
					case REQ_STAT_3:
						light = (char *)malloc(BRIGHT_BUF);
						sprintf(sql, ROOM_SELECT, 3);
						select_data_status(con, sql, &temp, &humi, &light);
						sprintf(strBuf, "%.2f_%.2f_%s", temp, humi, light);
						NetSend(clisock_list[i], strBuf);
						free(light);
						break;
					//   ȸ
					case REQ_STAT_4:
						pCon1 = (char *)malloc(BRIGHT_BUF); pCon2 = (char *)malloc(BRIGHT_BUF); pCon3 = (char *)malloc(BRIGHT_BUF);
						pCon4 = (char *)malloc(BRIGHT_BUF); pCon5 = (char *)malloc(BRIGHT_BUF); pCon6 = (char *)malloc(BRIGHT_BUF);
						sprintf(sql, LAMP_SELECT, 1);
						select_data_control(con, sql, &pCon1, &pCon2, &pCon3);
						sprintf(sql, APP_SELECT, 1);
						select_data_control(con, sql, &pCon4, &pCon5, &pCon6);
						sprintf(strBuf, "%s_%s_%s_%s_%s_%s\n", pCon1, pCon2, pCon3, pCon4, pCon5, pCon6);
						NetSend(clisock_list[i], strBuf);
						free(pCon1); free(pCon2); free(pCon3); free(pCon4); free(pCon5); free(pCon6);
						break;
					case REQ_STAT_5:
						pCon1 = (char *)malloc(BRIGHT_BUF); pCon2 = (char *)malloc(BRIGHT_BUF); pCon3 = (char *)malloc(BRIGHT_BUF);
						pCon4 = (char *)malloc(BRIGHT_BUF); pCon5 = (char *)malloc(BRIGHT_BUF); pCon6 = (char *)malloc(BRIGHT_BUF);
						sprintf(sql, LAMP_SELECT, 2);
						select_data_control(con, sql, &pCon1, &pCon2, &pCon3);
						sprintf(sql, APP_SELECT, 2);
						select_data_control(con, sql, &pCon4, &pCon5, &pCon6);
						sprintf(strBuf, "%s_%s_%s_%s_%s_%s\n", pCon1, pCon2, pCon3, pCon4, pCon5, pCon6);
						NetSend(clisock_list[i], strBuf);
						free(pCon1); free(pCon2); free(pCon3); free(pCon4); free(pCon5); free(pCon6);
						break;
					case REQ_STAT_6:
						pCon1 = (char *)malloc(BRIGHT_BUF); pCon2 = (char *)malloc(BRIGHT_BUF); pCon3 = (char *)malloc(BRIGHT_BUF);
						pCon4 = (char *)malloc(BRIGHT_BUF); pCon5 = (char *)malloc(BRIGHT_BUF); pCon6 = (char *)malloc(BRIGHT_BUF);
						sprintf(sql, LAMP_SELECT, 3);
						select_data_control(con, sql, &pCon1, &pCon2, &pCon3);
						sprintf(sql, APP_SELECT, 3);
						select_data_control(con, sql, &pCon4, &pCon5, &pCon6);
						sprintf(strBuf, "%s_%s_%s_%s_%s_%s\n", pCon1, pCon2, pCon3, pCon4, pCon5, pCon6);
						NetSend(clisock_list[i], strBuf);
						free(pCon1); free(pCon2); free(pCon3); free(pCon4); free(pCon5); free(pCon6);
						break;
					// ǳ ȯ 
					case REQ_SET1:
						get_Value(&set_temp, &set_humi);
						sprintf(sql, SET_UPDATE, CON_SET1, set_temp, CON_SET2, set_humi, 1);
						manage_data(con,sql);
						break;
					case REQ_SET2:
						get_Value(&set_temp, &set_humi);
						sprintf(sql, SET_UPDATE, CON_SET1, set_temp, CON_SET2, set_humi, 2);
						manage_data(con,sql);
						break;
					case REQ_SET3:
						get_Value(&set_temp, &set_humi);
						sprintf(sql, SET_UPDATE, CON_SET1, set_temp, CON_SET2, set_humi, 3);
						manage_data(con,sql);
						break;
					// ROOM1  
					case REQ_CON1:						
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP1, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "1" , SHORT_BUF);
						break;
					case REQ_CON2:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP1, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "2" , SHORT_BUF);
						break;
					case REQ_CON3:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP2, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "3" , SHORT_BUF);
						break;
					case REQ_CON4:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP2, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "4" , SHORT_BUF);
						break;
					case REQ_CON5:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP3, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "5" , SHORT_BUF);
						break;
					case REQ_CON6:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP3, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "6" , SHORT_BUF);
						break;
					case REQ_CON7:
						sprintf(sql, ALL_UPDATE, CON_LAMP, CON_LAMP1, ON_TEXT, CON_LAMP2, ON_TEXT, CON_LAMP3, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "7" , SHORT_BUF);
						break;
					case REQ_CON8:
						sprintf(sql, ALL_UPDATE, CON_LAMP, CON_LAMP1, OFF_TEXT, CON_LAMP2, OFF_TEXT, CON_LAMP3, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "8" , SHORT_BUF);
						break;
					case REQ_CON9:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP1, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "9" , SHORT_BUF);
						break;
					case REQ_CON10:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP1, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "0" , SHORT_BUF);
						break;
					case REQ_CON11:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP2, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "a" , SHORT_BUF);
						break;
					case REQ_CON12:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP2, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "b" , SHORT_BUF);
						break;
					case REQ_CON13:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP3, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "c" , SHORT_BUF);
						break;
					case REQ_CON14:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP3, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "d" , SHORT_BUF);
						break;
					case REQ_CON15:
						sprintf(sql, ALL_UPDATE, CON_APP, CON_APP1, ON_TEXT, CON_APP2, ON_TEXT, CON_APP3, ON_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "e" , SHORT_BUF);
						break;
					case REQ_CON16:
						sprintf(sql, ALL_UPDATE, CON_APP, CON_APP1, OFF_TEXT, CON_APP2, OFF_TEXT, CON_APP3, OFF_TEXT, 1);
						manage_data(con,sql);
						write(nSerialFD, "f" , SHORT_BUF);
						break;
					// ROOM2  
					case REQ_CON17:						
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP1, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON18:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP1, OFF_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON19:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP2, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON20:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP2, OFF_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON21:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP3, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON22:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP3, OFF_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON23:
						sprintf(sql, ALL_UPDATE, CON_LAMP, CON_LAMP1, ON_TEXT, CON_LAMP2, ON_TEXT, CON_LAMP3, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON24:
						sprintf(sql, ALL_UPDATE, CON_LAMP, CON_LAMP1, OFF_TEXT, CON_LAMP2, OFF_TEXT, CON_LAMP3, OFF_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON25:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP1, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON26:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP1, OFF_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON27:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP2, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON28:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP2, OFF_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON29:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP3, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON30:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP3, OFF_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON31:
						sprintf(sql, ALL_UPDATE, CON_APP, CON_APP1, ON_TEXT, CON_APP2, ON_TEXT, CON_APP3, ON_TEXT, 2);
						manage_data(con,sql);
						break;
					case REQ_CON32:
						sprintf(sql, ALL_UPDATE, CON_APP, CON_APP1, OFF_TEXT, CON_APP2, OFF_TEXT, CON_APP3, OFF_TEXT, 2);
						manage_data(con,sql);
					// ROOM3  
					case REQ_CON33:						
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP1, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON34:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP1, OFF_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON35:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP2, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON36:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP2, OFF_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON37:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP3, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON38:
						sprintf(sql, CON_UPDATE, CON_LAMP, CON_LAMP3, OFF_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON39:
						sprintf(sql, ALL_UPDATE, CON_LAMP, CON_LAMP1, ON_TEXT, CON_LAMP2, ON_TEXT, CON_LAMP3, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON40:
						sprintf(sql, ALL_UPDATE, CON_LAMP, CON_LAMP1, OFF_TEXT, CON_LAMP2, OFF_TEXT, CON_LAMP3, OFF_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON41:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP1, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON42:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP1, OFF_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON43:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP2, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON44:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP2, OFF_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON45:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP3, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON46:
						sprintf(sql, CON_UPDATE, CON_APP, CON_APP3, OFF_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON47:
						sprintf(sql, ALL_UPDATE, CON_APP, CON_APP1, ON_TEXT, CON_APP2, ON_TEXT, CON_APP3, ON_TEXT, 3);
						manage_data(con,sql);
						break;
					case REQ_CON48:
						sprintf(sql, ALL_UPDATE, CON_APP, CON_APP1, OFF_TEXT, CON_APP2, OFF_TEXT, CON_APP3, OFF_TEXT, 3);
						manage_data(con,sql);
					default :
						break;
				}
				removeClient(i);
			}
		}
	}

	//  ݱ
	CloseNetwork(nSocket);
	close_serial(nSerialFD);
	DB_Disconnect(con, error);

	return 0;
}

// Ŭ̾Ʈ  ߰
void addClient(int s, struct sockaddr_in *newcliaddr)
{
	char buf[20];
	inet_ntop(AF_INET, &newcliaddr->sin_addr, buf, sizeof(buf));
	printf("new client : %s\n", buf);
	clisock_list[client_count] = s;
	client_count++;
}

// Ŭ̾Ʈ 
void removeClient(int s)
{
	close(clisock_list[s]);
	if(s != client_count - 1)
		clisock_list[s] = clisock_list[client_count - 1];
	client_count--;
	printf("remove client\n");
}

// ִ   
int getmax()
{
	int max = nSocket;
	int i;
	for(i=0; i < client_count; i++)
		if(clisock_list[i] > max)
		max = clisock_list[i];
	return max;
}