package com.cslab.HomeApp;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;

public class HomeApp extends Activity implements OnClickListener{
	/** Called when the activity is first created. */
	Intent i;
	private static final int STATUS_ID_1 = 0;
	private static final int STATUS_ID_2 = 1;
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        // Button Event Listener 
        View HomestatButton = this.findViewById(R.id.Main_Button_01);
        HomestatButton.setOnClickListener(this);
        View RoomstatButton = this.findViewById(R.id.Main_Button_02);
        RoomstatButton.setOnClickListener(this);
        View UserProfileButton = this.findViewById(R.id.Main_Button_03);
        UserProfileButton.setOnClickListener(this);
        View HelpButton = this.findViewById(R.id.Main_Button_04);
        HelpButton.setOnClickListener(this);
    }

    // Button Event
	@Override
	public void onClick(View v) {
		switch (v.getId()) {
			// Activity Start
			case R.id.Main_Button_01:
				i = new Intent(this, RoomList.class);
				startActivity(i);
				break;
			case R.id.Main_Button_02:
				i = new Intent(this, Lamp_control.class);
				startActivity(i);
				break;
			case R.id.Main_Button_03:
				i = new Intent(this, Appliance_control.class);
				startActivity(i);
				break;
			case R.id.Main_Button_04:
				i = new Intent(this, MyHome.class);
				startActivity(i);
				break;
		}
	}
	
	// Menu Create
	public boolean onCreateOptionsMenu(Menu menu) {
		super.onCreateOptionsMenu(menu);
		MenuItem Settings = menu.add(0, STATUS_ID_1, 0, R.string.Main_Menu_01);
		MenuItem Helper = menu.add(0, STATUS_ID_2, 0, R.string.Main_Menu_02);
		
		Settings.setIcon(R.drawable.setting);
		Helper.setIcon(R.drawable.help);
		
		return true;
	}
	
	// Menu Event
	@Override
	public boolean onOptionsItemSelected(MenuItem item){
		super.onOptionsItemSelected(item);
		
		switch(item.getItemId()) {
			case STATUS_ID_1:
				i = new Intent(this, HomeApp_Setting.class);
				startActivity(i);
				return true;
			case STATUS_ID_2:
				return true;
		}
		return false;
	}
}