package com.cslab.HomeApp;

import java.util.ArrayList;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.AdapterView.OnItemClickListener;

public class RoomList extends Activity implements OnClickListener {
	/** Called when the activity is first created. */
	private ListView RoomList;
	private String RoomNum = null;
	static final private int Failed_Diglog = 1;
	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.roomlist);
	    
	    // Button Event Listener 
	    RoomList = (ListView)findViewById(R.id.RoomList_List);
	    Button room_status1 = (Button)findViewById(R.id.room_status);
	    Button room_status2 = (Button)findViewById(R.id.app_status);
	    Button room_setting = (Button)findViewById(R.id.room_setting);
	    room_status1.setOnClickListener(this);
	    room_status2.setOnClickListener(this);
	    room_setting.setOnClickListener(this);
	    
	    // ListView 
	    final ArrayList<String> RoomListItem = new ArrayList<String>();
	    RoomListItem.add("ȹ");
	    RoomListItem.add("Ž");
	    RoomListItem.add("");
	    
	    final ArrayAdapter<String> List_String;
	    List_String = new ArrayAdapter<String>(this, 
	    		android.R.layout.simple_list_item_single_choice, RoomListItem);
	    
	    RoomList.setAdapter(List_String);
	    List_String.notifyDataSetChanged();
	    RoomList.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
	    
	    // ListView Event
	    RoomList.setOnItemClickListener(new OnItemClickListener() {
	    	public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
	    		// õ Listview ڿ 
	    		RoomNum = (String)List_String.getItem(arg2);
	    	}
	    });
	}
	
	// Button Event
	@Override
	public void onClick(View v) {
		Intent i;
		switch (v.getId()) {
			case R.id.room_status:
				//  õ ʾ 
				if(RoomNum == null)
					showDialog(Failed_Diglog);
				// Intent RoomNum ϰ  Ѱֱ
				else {
					i = new Intent(this, RoomStatus.class);
					i.putExtra("data_room", RoomNum);
					startActivity(i);
				}
				break;
			case R.id.room_setting:
				if(RoomNum == null)
					showDialog(Failed_Diglog);
				else {
					i = new Intent(this, RoomSetting.class);
					i.putExtra("data_room", RoomNum);
					startActivity(i);
				}
				break;
			case R.id.app_status:
				if(RoomNum == null)
					showDialog(Failed_Diglog);
				else {
					i = new Intent(this, ApplianceStatus.class);
					i.putExtra("data_room", RoomNum);
					startActivity(i);
				}
				break;
		}
	}
	
	// Error Dialog
	@Override
	public Dialog onCreateDialog(int id){
		String button1_String = "Ȯ";
		switch(id) {
			case (Failed_Diglog) :
				AlertDialog.Builder Dialog_1 = new AlertDialog.Builder(this);
				Dialog_1.setTitle("");
				Dialog_1.setMessage("  ֽʽÿ");
				Dialog_1.setPositiveButton(button1_String, null);
				return Dialog_1.create();
		}
		return null;
	}
}
